<?php

namespace AMZcockpitDoctrine\Repository;

use AMZcockpitDoctrine\Entity\MWS\Store;
use AMZcockpitDoctrine\Entity\Email;
use AMZcockpitDoctrine\Entity\EmailBroadcast;
use AMZcockpitDoctrine\Entity\EmailBroadcastAdmin;
use AMZcockpitDoctrine\Entity\EmailJob;
use Doctrine\ORM\QueryBuilder;
use AMZcockpitDoctrine\Entity\User;

/**
 * EmailJobRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class EmailJobRepository extends \Doctrine\ORM\EntityRepository
{
    public function getEmailsQueueByUser(User $user, $offset = 0, $limit = 100)
    {
        $qb = $this->createQueryBuilder('ej')
            ->select('ej');
        $qb->leftJoin('ej.email','e')
           ->leftJoin('ej.emailBroadcast','eb')
            ->andWhere($qb->expr()->orX(
                'ej.email IS NOT NULL',
                   'ej.emailBroadcast IS NOT NULL'
            ))
            ->andWhere(
                $qb->expr()->orX(
                    'e.user = :user',
                    'eb.user = :user'
                )
            )->setParameter('user', $user)
        ;
        $qb->orderBy('ej.id','DESC');
        $qb->setMaxResults($limit);
        $qb->setFirstResult($offset);

        return  $qb->getQuery()->getResult();
    }

    public function getTotalEmailsQueueByUser(User $user)
    {
        $qb = $this->createQueryBuilder('ej')
            ->select('COUNT(ej)');
        $qb->leftJoin('ej.email','e')
           ->leftJoin('ej.emailBroadcast','eb')
            ->andWhere($qb->expr()->orX(
                'ej.email IS NOT NULL',
                   'ej.emailBroadcast IS NOT NULL'
            ))
            ->andWhere(
                $qb->expr()->orX(
                    'e.user = :user',
                    'eb.user = :user'
                )
            )->setParameter('user', $user)
        ;

        return  $qb->getQuery()->getSingleScalarResult();
    }

    public function getEmailsQueueForAdmin()
    {
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->leftJoin('ej.email','e')
            ->andWhere('e.id IS NULL')
        ;
        $qb->addSelect('(CASE WHEN ej.status = \'waiting\' then 0 ELSE 1 END) AS HIDDEN status');
        $qb->orderBy('ej.date', 'ASC');

        return  $qb->getQuery()->getResult();
    }

    public function getWaitingJobsToSend()
    {
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->where('ej.status = :status')->setParameter('status', EmailJob::WAITING);
        $qb->andWhere($qb->expr()->lte('ej.date',':date'))->setParameter('date',new \DateTime('now'));
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->isNotNull('ej.email'),
                $qb->expr()->andX(
                    $qb->expr()->isNull('ej.email'),
                    $qb->expr()->isNull('ej.order')
                )
            )
        );
        $qb->orderBy('ej.date', 'ASC');
        $qb->addOrderBy('ej.status', 'ASC');
        $qb->setMaxResults(100);

        return  $qb->getQuery()->getResult();
    }

    public function getWaitingJobsToResend()
    {
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->where('ej.status = :status')->setParameter('status', EmailJob::COMPLETE);
        $qb->andWhere('ej.autoResend = :autoResend')->setParameter('autoResend', false);
        $qb->andWhere('ej.isOpened = :isOpened')->setParameter('isOpened', false);
        $qb->leftJoin('ej.email','e');
        $qb->andWhere('e.autoResend = :isAutoResend')->setParameter('isAutoResend', true);
        $qb->andWhere($qb->expr()->gte('ej.date', 'e.dateStartAutoResend'));
        $qb->andWhere($qb->expr()->lte('e.dateStartAutoResend',':dateStartAutoResend'))
            ->setParameter('dateStartAutoResend', new \DateTime('now'));
        $qb->andWhere($qb->expr()->gte('ej.date', ':firstDay'))
            ->setParameter('firstDay',  \DateTime::createFromFormat('d/m/Y H:i:s','01/01/2019 00:00:00'));
        return  $qb->getQuery()->getResult();
    }

    public function getWaitingBroadcastJobsToSend()
    {
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->where('ej.status = :status')->setParameter('status', EmailJob::WAITING);
        $qb->andWhere($qb->expr()->lte('ej.date',':date'))->setParameter('date',new \DateTime('now'));
        $qb->andWhere($qb->expr()->isNotNull('ej.emailBroadcast'));
        $qb->orderBy('ej.date', 'ASC');
        $qb->addOrderBy('ej.status', 'ASC');

        return  $qb->getQuery()->getResult();
    }

    public function getEmailOpenedPercent(Email $email) {
        $qb = $this->createQueryBuilder('ej')->select('COUNT(ej) as _count');
        $qb->where('ej.email = :email')->setParameter('email', $email)
            ->andWhere('ej.status = :status')->setParameter('status',EmailJob::COMPLETE)
            ->groupBy('ej.isOpened');
        $items = $qb->getQuery()->getResult();
        $total = 0;
        $openedPercent = 0;
        foreach ($items as $item) $total+= $item['_count'];
        if(isset($items[1])) {
            $openedPercent = number_format(($items[1]['_count']/$total)*100,2).'%';
        }
        return $openedPercent;
    }

    public function getOpenedAndSentMonthly(Email $email = null, $user = null) {
        $qb = $this->createQueryBuilder('ej');
        if($email)
            $qb->where('ej.email = :email')->setParameter('email', $email);
        elseif($user) {
            $qb->leftJoin('ej.email','e')
                ->where('e.user = :user')->setParameter('user', $user);
        } else {
            return null;
        }
        $qb->andWhere($qb->expr()->isNull('ej.emailBroadcast'));

        $qb->select('ej.isOpened, COUNT(ej) as gCount, MONTH(ej.date) AS gDmonth, YEAR(ej.date) AS gDyear')
            ->andWhere($qb->expr()->eq('ej.status', ':sent'))->setParameter('sent',EmailJob::COMPLETE)
            ->groupBy('gDmonth')
            ->addGroupBy('gDyear')
            ->addGroupBy('ej.isOpened');

        $result  = $qb->getQuery()->getResult();
        $mois = [ "Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre" ];
        $items = $values = [];
        if(!$result){
            $year = date('Y');
            for($i=0; $i<12; $i++) {
                $items[$year][$mois[$i]] = ['opened' => 0, 'sent' => 0];
            }
            return $items;
        }

        foreach ($result as $item) {
            if(!isset($values[$item['gDyear']][$item['gDmonth']-1]))
                $values[$item['gDyear']][$item['gDmonth']-1] = ['opened' => 0, 'sent' => 0];
            if(isset($values[$item['gDyear']][$item['gDmonth']-1]['sent']))
                $values[$item['gDyear']][$item['gDmonth']-1]['sent'] += $item['gCount'];
            else
                $values[$item['gDyear']][$item['gDmonth']-1]['sent'] = $item['gCount'];
            if($item['isOpened'])
                $values[$item['gDyear']][$item['gDmonth']-1]['opened'] = (int)$item['gCount'];
        }

        $return = [];
        $maxYear = 0;
        foreach ($values as $year => $months) {
            if($maxYear < $year ) $maxYear = $year;
            for($i=0; $i<12; $i++) {
                if(isset($values[$year][$i])) {
                    $months[$i]['month'] = $mois[$i];
                    $return[$year][] = $months[$i];
                } else {
                    $return[$year][] = ['month' => $mois[$i], 'opened' => 0, 'sent' => 0];
                }
            }
        }

        return $return[$maxYear];
    }

    public function getEmailBroadcastOpenedAndSentMonthly(EmailBroadcast $email = null, $user = null) {
        $qb = $this->createQueryBuilder('ej');
        if($email)
            $qb->where('ej.emailBroadcast = :email')->setParameter('email', $email);
        elseif($user) {
            $qb->leftJoin('ej.emailBroadcast','e')
                ->where('e.user = :user')->setParameter('user', $user);
        } else {
            return null;
        }
        $qb->andWhere($qb->expr()->isNull('ej.email'));

        $qb->select('ej.isOpened, COUNT(ej) as gCount, MONTH(ej.date) AS gDmonth, YEAR(ej.date) AS gDyear')
            ->andWhere($qb->expr()->eq('ej.status', ':sent'))->setParameter('sent',EmailJob::COMPLETE)
            ->groupBy('gDmonth')
            ->addGroupBy('gDyear')
            ->addGroupBy('ej.isOpened');

        $result  = $qb->getQuery()->getResult();
        $mois = [ "Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre" ];
        $items = $values = [];
        if(!$result){
            $year = date('Y');
            for($i=0; $i<12; $i++) {
                $items[$year][$mois[$i]] = ['opened' => 0, 'sent' => 0];
            }
            return $items;
        }

        foreach ($result as $item) {
            if(isset($values[$item['gDyear']][$item['gDmonth']-1]['sent']))
                $values[$item['gDyear']][$item['gDmonth']-1]['sent'] += $item['gCount'];
            else
                $values[$item['gDyear']][$item['gDmonth']-1]['sent'] = $item['gCount'];
            if($item['isOpened'])
                $values[$item['gDyear']][$item['gDmonth']-1]['opened'] = (int)$item['gCount'];
        }

        $return = [];
        $maxYear = 0;
        foreach ($values as $year => $months) {
            if($maxYear < $year ) $maxYear = $year;
            for($i=0; $i<12; $i++) {
                if(isset($values[$year][$i])) {
                    $months[$i]['month'] = $mois[$i];
                    $return[$year][] = $months[$i];
                } else {
                    $return[$year][] = ['month' => $mois[$i], 'opened' => 0, 'sent' => 0];
                }
            }
        }

        return $return[$maxYear];
    }

    public function getEmailUsedLastMonth(User $user) {

        $qb = $this->createQueryBuilder('ej');
        $qb->select('COUNT(ej)')->leftJoin('ej.email','e');
        $qb->where($qb->expr()->eq('e.user',':user'))
            ->andWhere($qb->expr()->between('ej.createdAt', ':date', ':dateEnd'))
            ->setParameter('user',$user)
            ->setParameter('date',$user->getCurrentPeriodeStart())
            ->setParameter('dateEnd',$user->getCurrentPeriodeEnd());

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getJobsBetweenTwoDates(\DateTime $dateStart,\DateTime $dateEnd) {

        $qb = $this->createQueryBuilder('ej');
        $qb
            ->select('ej')
            ->leftJoin('ej.order','o')
            ->where($qb->expr()->between('ej.date', ':dateStart', ':dateEnd'))
            ->andWhere($qb->expr()->eq('o.store',':store'))
            ->andWhere($qb->expr()->eq('ej.status',':status'))
            ->setParameter('dateStart',$dateStart)
            ->setParameter('dateEnd',$dateEnd)
            ->setParameter('status', EmailJob::COMPLETE)
            ->setParameter('store', 68);

        return $qb->getQuery()->getResult();
    }

    public function getOpenedEmailByEmailBroadcast(EmailBroadcast $email) {

        $qb = $this->createQueryBuilder('ej');
        $qb->select('COUNT(ej)');
        $qb->where($qb->expr()->eq('ej.emailBroadcast',':email'))
            ->setParameter('email',$email);
        $qb->andWhere($qb->expr()->eq('ej.isOpened',':opened'))
            ->setParameter('opened',true);

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getOpenedEmailByEmailBroadcastAdmin(EmailBroadcastAdmin $email) {

        $qb = $this->createQueryBuilder('ej');
        $qb->select('COUNT(ej)');
        $qb->where($qb->expr()->eq('ej.emailBroadcastAdmin',':email'))
            ->setParameter('email',$email);
        $qb->andWhere($qb->expr()->eq('ej.isOpened',':opened'))
            ->setParameter('opened',true);

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getAverageEmailUsageByUser(User $user) {

        $qb = $this->createQueryBuilder('ej');
        $qb->select('COUNT(ej) as _count, MONTH(ej.date) AS gDmonth, YEAR(ej.date) AS gDyear')
            ->leftJoin('ej.email','e');
        $qb->where($qb->expr()->eq('e.user',':user'))
            ->setParameter('user',$user)
            ->groupBy('gDyear')
            ->addGroupBy('gDmonth');

        $items = $qb->getQuery()->getResult();
        $monthsCount = count($items);
        $count = 0;
        foreach ($items as $item)
            $count +=$item['_count'];

        return $monthsCount == 0 ? 0 : (int)round($count/$monthsCount);
    }

    public function getDuplicatedEmails(Store $store = null) {

        $qb = $this->createQueryBuilder('ej');
        $qb->select('ej')
            ->groupBy('ej.order')
            ->addGroupBy('ej.email');

        $qb->andWhere($qb->expr()->eq('o.store',':store'))
            ->setParameter('store',$store);

        $qb->having('COUNT(o) > 1');
        return $qb->getQuery()->getResult();
    }

    public function getReviewsSnapshot(User $user) {
        $return = [];
        $days = [7, 30, 90, 180, 365];
        $i = 0;
        while(isset($days[$i])) {
            $date = (new \DateTime('now'))->sub(new \DateInterval('P'.$days[$i].'D'));
            $qb = $this->createQueryBuilder('ej');
            $qb->select('COUNT(ej) AS _count')
                ->leftJoin('ej.email','e')
                ->where('e.user = :user')
                ->setParameter('user', $user);

            $qb->andWhere($qb->expr()->gte('ej.date',':date'))->setParameter('date',$date);
            $orderCounts = $qb->getQuery()->getSingleScalarResult();
            $return[$days[$i]] = $orderCounts;
            $i++;
        }
        return $return;
    }

    /**
     * @return array
     */
    public function getEmailsJobsCountLastMonth() {

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('e');
        $qb->select('u.email, COUNT(e) as _count');
        $qb->leftJoin('e.order','o');
        $qb->leftJoin('o.store','s');
        $qb->leftJoin('s.user','u')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(($qb->expr()->eq('s.validated',':validated')))
            ->setParameter('validated',true)
            ->andWhere('e.createdAt BETWEEN :from AND :to')
            ->setParameter('from', ':from' )
            ->setParameter('to', ':to')
            ->setParameter('from','2018-09-29 00:00:00')
            ->setParameter('to','2018-10-29 00:00:00');
        $qb->groupBy('u');

        $items = $qb->getQuery()->getResult();
        $return = [];
        foreach ($items as $item) {
            $return[$item['email']] = [
                'emails_count' => $item['_count']
            ];
        }
        return $return;
    }

    /**
     * @return array
     */
    public function getExpiredEmailJobs($limit) {
        $maxDate = (new \DateTime('now'))->sub(new \DateInterval('P3M'));
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->where($qb->expr()->in('ej.status', ':status'))
            ->setParameter('status', [EmailJob::COMPLETE, EmailJob::CANCELED]);
        $qb->andWhere($qb->expr()->lte('ej.date',':date'))
            ->setParameter('date',$maxDate);
        $qb->orderBy('ej.date', 'ASC');
        $qb->setMaxResults($limit);

        return  $qb->getQuery()->getResult();
    }

    public function getPendingJobsToSend(User $user)
    {
        $qb = $this->createQueryBuilder('ej')->select('ej');
        $qb->leftJoin('ej.order','o');
        $qb->leftJoin('o.store','s');
        $qb->where('ej.status = :status')->setParameter('status', EmailJob::PENDING);
        $qb->andWhere($qb->expr()->isNotNull('ej.order'));
        $qb->andWhere($qb->expr()->eq('s.user',':user'));
        $qb->andWhere($qb->expr()->lte('ej.createdAt',':date'))->setParameter('date',new \DateTime('now'));
        $qb->setParameter('user', $user);
        $qb->orderBy('ej.date', 'ASC');
        $qb->addOrderBy('ej.status', 'ASC');

        return  $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getDailyStatisticsReport() {

        $from = (new \DateTime('now'))->sub(new \DateInterval('P31D'));
        $to = new \DateTime('now');
        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('ej');
        $qb->select('ej.date, DAY(ej.date) AS gDay, MONTH(ej.date) AS gDmonth, YEAR(ej.date) AS gDyear, COUNT(ej.id) as _count');
        $qb->addGroupBy('gDay');
        $qb->addGroupBy('gDmonth');
        $qb->addGroupBy('gDyear');
        $qb->orderBy('ej.date','ASC');

        $qb->where($qb->expr()->lte('ej.date',  ':to'))
            ->andWhere($qb->expr()->gte('ej.date',  ':from'))
            ->setParameter('from', $from)
            ->setParameter('to', $to);
        $qb->andWhere('ej.status = :status')->setParameter('status', EmailJob::COMPLETE);
        $items = $qb->getQuery()->getResult();

        $return = [];
        foreach ($items as $item) {
            $return[] = [
                'date' => $item['date']->format('Y-m-d'),
                'value' => (int)$item['_count']
            ];
        }

        return $return;
    }

    public function getTotalEmailsSent() {
        $qb = $this->createQueryBuilder('ej')
            ->select('COUNT(ej)');
        $qb->where($qb->expr()->in('ej.status', ':status'))
            ->setParameter('status', [EmailJob::COMPLETE]);;

        return  $qb->getQuery()->getSingleScalarResult();
    }

    public function getWaitingEmailsJobsByUser(User $user) {
        $qb = $this->createQueryBuilder('ej')
            ->select('COUNT(ej) as _count');

        $qb
            ->leftJoin('ej.email', 'e')
            ->where('e.user = :user')
            ->setParameter('user', $user)

            ->andWhere('ej.status IN (:status)')
            ->setParameter('status',[EmailJob::WAITING, EmailJob::PENDING]);

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getSentEmailsJobsByUser(User $user) {
        $qb = $this->createQueryBuilder('ej')
            ->select('COUNT(ej) as _count');

        $qb
            ->leftJoin('ej.email', 'e')
            ->where('e.user = :user')
            ->setParameter('user', $user)

            ->andWhere('ej.status IN (:status)')
            ->setParameter('status',[EmailJob::COMPLETE]);

        return $qb->getQuery()->getSingleScalarResult();
    }
}
